<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::FileAdapter Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1FileAdapter.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1FileAdapter-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::FileAdapter Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a class="el" href="classOpenSim_1_1FileAdapter.html" title="FileAdapter is a DataAdapter that reads and writes files with methods read and writeFile respectively...">FileAdapter</a> is a <a class="el" href="classOpenSim_1_1DataAdapter.html" title="DataAdapter is an abstract class defining an interface for reading/writing in/out the contents of a D...">DataAdapter</a> that reads and writes files with methods read and writeFile respectively.  
 <a href="classOpenSim_1_1FileAdapter.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::FileAdapter:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1FileAdapter.png" usemap="#OpenSim::FileAdapter_map" alt=""/>
  <map id="OpenSim::FileAdapter_map" name="OpenSim::FileAdapter_map">
<area href="classOpenSim_1_1DataAdapter.html" title="DataAdapter is an abstract class defining an interface for reading/writing in/out the contents of a D..." alt="OpenSim::DataAdapter" shape="rect" coords="238,0,466,24"/>
<area href="classOpenSim_1_1DelimFileAdapter.html" alt="OpenSim::DelimFileAdapter&lt; double &gt;" shape="rect" coords="0,112,228,136"/>
<area href="classOpenSim_1_1DelimFileAdapter.html" title="DelimFileAdapter is a FileAdapter that reads and writes text files with given delimiters." alt="OpenSim::DelimFileAdapter&lt; T &gt;" shape="rect" coords="238,112,466,136"/>
<area href="classOpenSim_1_1TRCFileAdapter.html" title="TRCFileAdapter is a FileAdapter that reads and writes TRC files." alt="OpenSim::TRCFileAdapter" shape="rect" coords="476,112,704,136"/>
<area href="classOpenSim_1_1CSVFileAdapter.html" title="CSVFileAdapter is a DelimFileAdapter that presets the delimiters appropriately for CSV files." alt="OpenSim::CSVFileAdapter" shape="rect" coords="0,168,228,192"/>
<area href="classOpenSim_1_1STOFileAdapter__.html" title="STOFileAdapter is a DelimFileAdapter that presets the delimiters appropriately for STO files." alt="OpenSim::STOFileAdapter_&lt; T &gt;" shape="rect" coords="238,168,466,192"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab9fd3aecabcaa55035e2f639332facb6"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#ab9fd3aecabcaa55035e2f639332facb6">FileAdapter</a> ()=default</td></tr>
<tr class="separator:ab9fd3aecabcaa55035e2f639332facb6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a563304fb56a2583f9a021e708cfa2845"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a563304fb56a2583f9a021e708cfa2845">FileAdapter</a> (const <a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;)=default</td></tr>
<tr class="separator:a563304fb56a2583f9a021e708cfa2845"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9ec7bf8a52d8163ccfd1747528dc8c5e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a9ec7bf8a52d8163ccfd1747528dc8c5e">FileAdapter</a> (<a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&amp;)=default</td></tr>
<tr class="separator:a9ec7bf8a52d8163ccfd1747528dc8c5e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af34e37de460273c64c7902ed7756375a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#af34e37de460273c64c7902ed7756375a">operator=</a> (const <a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;)=default</td></tr>
<tr class="separator:af34e37de460273c64c7902ed7756375a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40c496a1500e36cbc11a5646d9e266cb"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a40c496a1500e36cbc11a5646d9e266cb">operator=</a> (<a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&amp;)=default</td></tr>
<tr class="separator:a40c496a1500e36cbc11a5646d9e266cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a85732be30639f7ed997b9d11df60cee8"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a85732be30639f7ed997b9d11df60cee8">~FileAdapter</a> ()=default</td></tr>
<tr class="separator:a85732be30639f7ed997b9d11df60cee8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classOpenSim_1_1DataAdapter"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classOpenSim_1_1DataAdapter')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classOpenSim_1_1DataAdapter.html">OpenSim::DataAdapter</a></td></tr>
<tr class="memitem:abf6ef44f97ac71f9cd1bd2b080491e85 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#abf6ef44f97ac71f9cd1bd2b080491e85">clone</a> () const =0</td></tr>
<tr class="separator:abf6ef44f97ac71f9cd1bd2b080491e85 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac36f915dd4045ef9c52344dd05efe654 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#ac36f915dd4045ef9c52344dd05efe654">DataAdapter</a> ()=default</td></tr>
<tr class="separator:ac36f915dd4045ef9c52344dd05efe654 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0008a82aec446f1b6355f461578eccfe inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a0008a82aec446f1b6355f461578eccfe">DataAdapter</a> (const <a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &amp;)=default</td></tr>
<tr class="separator:a0008a82aec446f1b6355f461578eccfe inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62febc0569d61bb65f640347e09d503d inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a62febc0569d61bb65f640347e09d503d">DataAdapter</a> (<a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &amp;&amp;)=default</td></tr>
<tr class="separator:a62febc0569d61bb65f640347e09d503d inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75c26383f9e5ae455ea804f07d04b763 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a75c26383f9e5ae455ea804f07d04b763">operator=</a> (const <a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &amp;)=default</td></tr>
<tr class="separator:a75c26383f9e5ae455ea804f07d04b763 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80a45642463cb62a05f6f62440855fca inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a80a45642463cb62a05f6f62440855fca">operator=</a> (<a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &amp;&amp;)=default</td></tr>
<tr class="separator:a80a45642463cb62a05f6f62440855fca inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fa627d27f596e810e49498e6eda8a16 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a1fa627d27f596e810e49498e6eda8a16">~DataAdapter</a> ()=default</td></tr>
<tr class="separator:a1fa627d27f596e810e49498e6eda8a16 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b8e9cede726e0eb399cb95c06f77b49 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1DataAdapter.html#aa70731950b2d90af75eb1f4066c43c47">DataAdapter::OutputTables</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a7b8e9cede726e0eb399cb95c06f77b49">read</a> (const std::string &amp;dataSourceSpecification) const</td></tr>
<tr class="memdesc:a7b8e9cede726e0eb399cb95c06f77b49 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="mdescLeft">&#160;</td><td class="mdescRight">Public interface to read data from a dataSourceSpecification, typically a file or folder.  <a href="classOpenSim_1_1DataAdapter.html#a7b8e9cede726e0eb399cb95c06f77b49">More...</a><br /></td></tr>
<tr class="separator:a7b8e9cede726e0eb399cb95c06f77b49 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a556503152419f313eb483897a1be41f4 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top">const std::shared_ptr&lt; <a class="el" href="classOpenSim_1_1AbstractDataTable.html">AbstractDataTable</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a556503152419f313eb483897a1be41f4">getDataTable</a> (const <a class="el" href="classOpenSim_1_1DataAdapter.html#aa70731950b2d90af75eb1f4066c43c47">OutputTables</a> &amp;tables, const std::string tableName)</td></tr>
<tr class="memdesc:a556503152419f313eb483897a1be41f4 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic interface to retrieve a specific table by name from read result.  <a href="classOpenSim_1_1DataAdapter.html#a556503152419f313eb483897a1be41f4">More...</a><br /></td></tr>
<tr class="separator:a556503152419f313eb483897a1be41f4 inherit pub_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a5cc85bf83a407507fd13a661cc88843a"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a5cc85bf83a407507fd13a661cc88843a">writeFile</a> (const <a class="el" href="classOpenSim_1_1DataAdapter.html#a77fcec7eb62bc89789fbf836389d5950">InputTables</a> &amp;tables, const std::string &amp;fileName)</td></tr>
<tr class="memdesc:a5cc85bf83a407507fd13a661cc88843a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a collection of tables to the given file.  <a href="classOpenSim_1_1FileAdapter.html#a5cc85bf83a407507fd13a661cc88843a">More...</a><br /></td></tr>
<tr class="separator:a5cc85bf83a407507fd13a661cc88843a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad76d0911221f80397d1b7c047984ddfa"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#ad76d0911221f80397d1b7c047984ddfa">findExtension</a> (const std::string &amp;filename)</td></tr>
<tr class="memdesc:ad76d0911221f80397d1b7c047984ddfa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find the extension from a filename.  <a href="classOpenSim_1_1FileAdapter.html#ad76d0911221f80397d1b7c047984ddfa">More...</a><br /></td></tr>
<tr class="separator:ad76d0911221f80397d1b7c047984ddfa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8408af2fdb34cbe7e0aff3083a2ba60d"><td class="memItemLeft" align="right" valign="top">static std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a8408af2fdb34cbe7e0aff3083a2ba60d">getNextLine</a> (std::istream &amp;stream, const std::string &amp;delims)</td></tr>
<tr class="memdesc:a8408af2fdb34cbe7e0aff3083a2ba60d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the next line from the stream and tokenize/split the line using the given delimiters.  <a href="classOpenSim_1_1FileAdapter.html#a8408af2fdb34cbe7e0aff3083a2ba60d">More...</a><br /></td></tr>
<tr class="separator:a8408af2fdb34cbe7e0aff3083a2ba60d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c0df59f7019f251683ba2c46b80de3e"><td class="memItemLeft" align="right" valign="top">static std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a4c0df59f7019f251683ba2c46b80de3e">tokenize</a> (const std::string &amp;str, const std::string &amp;delims)</td></tr>
<tr class="memdesc:a4c0df59f7019f251683ba2c46b80de3e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Tokenize/split a given string using the given delimiters.  <a href="classOpenSim_1_1FileAdapter.html#a4c0df59f7019f251683ba2c46b80de3e">More...</a><br /></td></tr>
<tr class="separator:a4c0df59f7019f251683ba2c46b80de3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12670e5d449cca8bf05f86e39a7741b9"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1FileAdapter.html#a12670e5d449cca8bf05f86e39a7741b9">createAdapterFromExtension</a> (const std::string &amp;fileName)</td></tr>
<tr class="memdesc:a12670e5d449cca8bf05f86e39a7741b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a concerte <a class="el" href="classOpenSim_1_1FileAdapter.html" title="FileAdapter is a DataAdapter that reads and writes files with methods read and writeFile respectively...">FileAdapter</a> based on the extension of the passed in file and return it.  <a href="classOpenSim_1_1FileAdapter.html#a12670e5d449cca8bf05f86e39a7741b9">More...</a><br /></td></tr>
<tr class="separator:a12670e5d449cca8bf05f86e39a7741b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_static_methods_classOpenSim_1_1DataAdapter"><td colspan="2" onclick="javascript:toggleInherit('pub_static_methods_classOpenSim_1_1DataAdapter')"><img src="closed.png" alt="-"/>&#160;Static Public Member Functions inherited from <a class="el" href="classOpenSim_1_1DataAdapter.html">OpenSim::DataAdapter</a></td></tr>
<tr class="memitem:a62f03a9de403f04f57ba03ca333407de inherit pub_static_methods_classOpenSim_1_1DataAdapter"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1DataAdapter.html#a62f03a9de403f04f57ba03ca333407de">registerDataAdapter</a> (const std::string &amp;identifier, const <a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a> &amp;adapter)</td></tr>
<tr class="memdesc:a62f03a9de403f04f57ba03ca333407de inherit pub_static_methods_classOpenSim_1_1DataAdapter"><td class="mdescLeft">&#160;</td><td class="mdescRight">Register a concrete <a class="el" href="classOpenSim_1_1DataAdapter.html" title="DataAdapter is an abstract class defining an interface for reading/writing in/out the contents of a D...">DataAdapter</a> by its unique string identifier.  <a href="classOpenSim_1_1DataAdapter.html#a62f03a9de403f04f57ba03ca333407de">More...</a><br /></td></tr>
<tr class="separator:a62f03a9de403f04f57ba03ca333407de inherit pub_static_methods_classOpenSim_1_1DataAdapter"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p><a class="el" href="classOpenSim_1_1FileAdapter.html" title="FileAdapter is a DataAdapter that reads and writes files with methods read and writeFile respectively...">FileAdapter</a> is a <a class="el" href="classOpenSim_1_1DataAdapter.html" title="DataAdapter is an abstract class defining an interface for reading/writing in/out the contents of a D...">DataAdapter</a> that reads and writes files with methods read and writeFile respectively. </p>
<p>The read method is implemented in the base class and it calls the virtual extendRead method implemented by format specific subclasses. Typically you don't need to call read explicitly if reading one DataTable from file, instead use a constructor of the table from the specific file. e.g. </p><div class="fragment"><div class="line"><a class="code" href="namespaceOpenSim.html#aca67cce5245fc8a1ac274999aa98deb6">TimeSeriesTableVec3</a> table(filename);</div>
<div class="ttc" id="anamespaceOpenSim_html_aca67cce5245fc8a1ac274999aa98deb6"><div class="ttname"><a href="namespaceOpenSim.html#aca67cce5245fc8a1ac274999aa98deb6">OpenSim::TimeSeriesTableVec3</a></div><div class="ttdeci">TimeSeriesTable_&lt; SimTK::Vec3 &gt; TimeSeriesTableVec3</div><div class="ttdoc">See TimeSeriesTable_ for details on the interface.</div><div class="ttdef"><b>Definition:</b> TimeSeriesTable.h:522</div></div>
</div><!-- fragment --> </div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ab9fd3aecabcaa55035e2f639332facb6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab9fd3aecabcaa55035e2f639332facb6">&#9670;&nbsp;</a></span>FileAdapter() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::FileAdapter::FileAdapter </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a563304fb56a2583f9a021e708cfa2845"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a563304fb56a2583f9a021e708cfa2845">&#9670;&nbsp;</a></span>FileAdapter() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::FileAdapter::FileAdapter </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a9ec7bf8a52d8163ccfd1747528dc8c5e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9ec7bf8a52d8163ccfd1747528dc8c5e">&#9670;&nbsp;</a></span>FileAdapter() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::FileAdapter::FileAdapter </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a85732be30639f7ed997b9d11df60cee8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a85732be30639f7ed997b9d11df60cee8">&#9670;&nbsp;</a></span>~FileAdapter()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual OpenSim::FileAdapter::~FileAdapter </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a12670e5d449cca8bf05f86e39a7741b9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a12670e5d449cca8bf05f86e39a7741b9">&#9670;&nbsp;</a></span>createAdapterFromExtension()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::shared_ptr&lt;<a class="el" href="classOpenSim_1_1DataAdapter.html">DataAdapter</a>&gt; OpenSim::FileAdapter::createAdapterFromExtension </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>fileName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a concerte <a class="el" href="classOpenSim_1_1FileAdapter.html" title="FileAdapter is a DataAdapter that reads and writes files with methods read and writeFile respectively...">FileAdapter</a> based on the extension of the passed in file and return it. </p>
<p>This serves as a Factory of FileAdapters so clients don't need to know specific concrete subclasses, as long as the generic base class read interface is used </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1DataTable__.html#acc8a6e876ff3b3ec9323f8ca73b9a1aa">OpenSim::DataTable_&lt; double, SimTK::Real &gt;::DataTable_()</a>, and <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html#a76de61a0d023184a20e2e0cd299eb1e9">OpenSim::TimeSeriesTable_&lt; SimTK::Real &gt;::TimeSeriesTable_()</a>.</p>

</div>
</div>
<a id="ad76d0911221f80397d1b7c047984ddfa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad76d0911221f80397d1b7c047984ddfa">&#9670;&nbsp;</a></span>findExtension()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::string OpenSim::FileAdapter::findExtension </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Find the extension from a filename. </p>
<p><br  />
 </p>

</div>
</div>
<a id="a8408af2fdb34cbe7e0aff3083a2ba60d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8408af2fdb34cbe7e0aff3083a2ba60d">&#9670;&nbsp;</a></span>getNextLine()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::vector&lt;std::string&gt; OpenSim::FileAdapter::getNextLine </td>
          <td>(</td>
          <td class="paramtype">std::istream &amp;&#160;</td>
          <td class="paramname"><em>stream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>delims</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the next line from the stream and tokenize/split the line using the given delimiters. </p>
<p><br  />
 </p>

</div>
</div>
<a id="af34e37de460273c64c7902ed7756375a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af34e37de460273c64c7902ed7756375a">&#9670;&nbsp;</a></span>operator=() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a>&amp; OpenSim::FileAdapter::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a40c496a1500e36cbc11a5646d9e266cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a40c496a1500e36cbc11a5646d9e266cb">&#9670;&nbsp;</a></span>operator=() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a>&amp; OpenSim::FileAdapter::operator= </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a> &amp;&amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a4c0df59f7019f251683ba2c46b80de3e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c0df59f7019f251683ba2c46b80de3e">&#9670;&nbsp;</a></span>tokenize()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::vector&lt;std::string&gt; OpenSim::FileAdapter::tokenize </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>delims</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Tokenize/split a given string using the given delimiters. </p>
<p>The delimiters are each required to be one character and the string is split if/when any of those characters are found. For example, a delimiter string " \t" specifies that either a space or a tab can act as the delimiter. <br  />
 </p>

</div>
</div>
<a id="a5cc85bf83a407507fd13a661cc88843a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5cc85bf83a407507fd13a661cc88843a">&#9670;&nbsp;</a></span>writeFile()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::FileAdapter::writeFile </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1DataAdapter.html#a77fcec7eb62bc89789fbf836389d5950">InputTables</a> &amp;&#160;</td>
          <td class="paramname"><em>tables</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>fileName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Write a collection of tables to the given file. </p>
<p>Different file formats require different number/type of tables. See specific adapter's documentation to see what is required. <br  />
 </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/FileAdapter.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1FileAdapter.html">FileAdapter</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:44 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
